﻿using System.Linq;
using DM;
using Factory;

namespace Service
{
    public class Teacher_S
    {
        public object FindAllTeacher()
        {
            var context = ContextFactory.GetContext();
            var a = ModelFactory.GetTeacher();
            var b = ModelFactory.GetContact();
            var aList = ModelListFactory.GetTeacherList();
            DMbase dm = new DMbase(context);
            var contact = dm.FindAll(b);
            var teacher = dm.FindAll(a);
            var asd = dm.FindAll(b);
            var result = teacher.Join(contact, o => o.ID, r => r.TeacherID, (o, r) => new { tt = o, aa = r });
            result = result.OrderByDescending(o => o.aa.Email);
            foreach (var item in result)
            {
                a = item.tt;
                a.Contact = item.aa;
                aList.Add(a);
            }
            return aList;
        }

        public bool AddTeacher<T, T1>(T teacher, T1 contact)
            where T : class,new()
            where T1 : class,new()
        {
            try
            {
                var context = ContextFactory.GetContext();
                DMbase dm = new DMbase(context);
                dm.Insert(teacher);
                dm.Insert(contact);
                dm.Commit();

                return true;
            }
            catch
            {
                return false;
            }
        }

        public bool DeleteTeacher<T, T1>(T teacher, T1 contact)
            where T : class,new()
            where T1 : class,new()
        {
            try
            {
                var context = ContextFactory.GetContext();
                DMbase dm = new DMbase(context);
                dm.Delete(teacher);
                dm.Delete(contact);
                dm.Commit();

                return true;
            }
            catch
            { 
                return false; 
            }
        }
    }
}
